/* Copyright (c) <2003-2011> <Julio Jerez, Newton Game Dynamics>
* 
* This software is provided 'as-is', without any express or implied
* warranty. In no event will the authors be held liable for any damages
* arising from the use of this software.
* 
* Permission is granted to anyone to use this software for any purpose,
* including commercial applications, and to alter it and redistribute it
* freely, subject to the following restrictions:
* 
* 1. The origin of this software must not be misrepresented; you must not
* claim that you wrote the original software. If you use this software
* in a product, an acknowledgment in the product documentation would be
* appreciated but is not required.
* 
* 2. Altered source versions must be plainly marked as such, and must not be
* misrepresented as being the original software.
* 
* 3. This notice may not be removed or altered from any source distribution.
*/

#ifndef __DG_THREAD_PROFILER_H__
#define __DG_THREAD_PROFILER_H__

#include "dgList.h"

#define DG_PROFILER_EVENT_NAME_SIZE  32

class dgThreadProfiler
{
	public:
	class dgEvent
	{
		public:
		char m_name[ DG_PROFILER_EVENT_NAME_SIZE];
		dgUnsigned32 m_startTime;
		dgUnsigned32 m_duration;
	};

	dgThreadProfiler ();
	dgThreadProfiler (const char* const name, dgInt32 id);
	virtual ~dgThreadProfiler ();
	
	dgUnsigned32 m_startTime;
	dgUnsigned32 m_endTime;
	dgList<dgEvent> m_events;
};



#endif
